 ![SFO icon](concept/icons/sfo_icon_h96.png)

Smart Force Optimization (SFO)
===============================================

SFO in a nutshell
-------------------
The innovative aspect about the SFO approach is the combination of a data base for storing all possible schedules 
and their corresponding constraints in advande and the subsquently selection of those schedules which are in compliance
with individiual constraints for a defined biogas plant set up by a SQL-query. This significantly reduced amount of schedules 
can than be used for a rather simple brute force optimization, which ohterwise would not be an appropriate approach  for the basic population.
An comprehensive description of the method an a demonstration for da generic biogas plant is given in the following scientific paper:
"Smart Force Optimisation – a modified exhaustive search method for flexible biogas plants under practical constraints" 
The manuscript was recently submitted, the final doi of the publication will be added here after the manuscript will be accepted, 
a preprint version is availible in the subdirectory [/paper](paper).

 ![SFO graphical abstract](concept/gitlab_wiki/sfo_graphical_abstract_gitlab.png)


Python configuration
-------------
The SFO is an open source optimization approach to generate schedules for price driven opertaion of flexible biogas plants,
considering typical constraints like gas storage, maximum nuber of strokes per day, daily runtime and also heat supply obligations. 
The library was developed and tested under python 3.7.9, it uses the following external packages (not part of the basic python core package):  

+ pandas
+ numpy
+ matplotlib



Directory structure
----------------------
root \
│ \
├─ concept - contain figures and the data base structure as well as the SFO-icon \
│ \
├─ csv 	- contains raw data for default heat load profiles (HLP) and power price profiles (PPP) \
│ \
├─ db 		- this folder will contain the databases of the schedules, \
│ \
├─ licence - contain the licence \
│ \
├─ paper 	- contain the [scientific paper](paper/smart_foce_optimisation_preprint.pdf) and the underlying workflows \
│ \
├─ png 	- contain template figures for the illustration of the diffrent plant classes \
│ \
└─ py 		- contain the python modules, a brief documentation is given in the [gitlab-wiki](https://gitlab.com/M.Dotzauer/SFO/-/wikis/home)

For the reason of a small data footprint the large data bases are exculed for this repository, 
but they can be generated by the supplied functions or rather use the static SFO-repository at [ZENODO](https://doi.org/10.5281/zenodo.6396172).


Copyright and licnece
---------------------

The Smart Force Optimization (SFO) is licencend under a Creative Commons Attribution 4.0 International Public License.
The lincence is part of this package and is referring to [creativecommons.org](https://creativecommons.org/licenses/by/4.0/legalcode).  

![CC-BY-4.0 icon](licence/CC_BY_h32.png) Martin Dotzauer, 2022  


Contact information
-------------------
The author can be reached via M.Dotzauer@posteo.eu.
